library organization_group;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../../serializers.dart';

part 'organizationGroup.g.dart';

abstract class OrganizationGroup
    implements Built<OrganizationGroup, OrganizationGroupBuilder> {
  OrganizationGroup._();

  factory OrganizationGroup([updates(OrganizationGroupBuilder b)]) =
      _$OrganizationGroup;

  @BuiltValueField(wireName: 'id')
  int get id;

  @BuiltValueField(wireName: 'organizationID')
  int get organizationID;

  @BuiltValueField(wireName: 'groupID')
  int get groupID;

  @BuiltValueField(wireName: 'groupName')
  String get groupName;

  String toJson() {
    return json
        .encode(serializers.serializeWith(OrganizationGroup.serializer, this));
  }

  static OrganizationGroup? fromJson(String jsonString) {
    return serializers.deserializeWith(
        OrganizationGroup.serializer, json.decode(jsonString));
  }

  static BuiltList<OrganizationGroup> listFromJson(jsonString) {
    return BuiltList<OrganizationGroup>.from(json
        .decode(jsonString)
        .map((value) =>
            serializers.deserializeWith(OrganizationGroup.serializer, value))
        .toList());
  }

  static Serializer<OrganizationGroup> get serializer =>
      _$organizationGroupSerializer;
}
