library session_request;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../../serializers.dart';

part 'sessionRequest.g.dart';

abstract class SessionRequest
    implements Built<SessionRequest, SessionRequestBuilder> {
  SessionRequest._();

  factory SessionRequest([updates(SessionRequestBuilder b)]) = _$SessionRequest;

  @BuiltValueField(wireName: 'email')
  String get email;

  @BuiltValueField(wireName: 'phone')
  String get phone;

  String toJson() {
    return json
        .encode(serializers.serializeWith(SessionRequest.serializer, this));
  }

  static SessionRequest? fromJson(String jsonString) {
    return serializers.deserializeWith(
        SessionRequest.serializer, json.decode(jsonString));
  }

  static BuiltList<SessionRequest> listFromJson(jsonString) {
    return BuiltList<SessionRequest>.from(json
        .decode(jsonString)
        .map((value) =>
            serializers.deserializeWith(SessionRequest.serializer, value))
        .toList());
  }

  static Serializer<SessionRequest> get serializer =>
      _$sessionRequestSerializer;
}
