library user_group;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../../serializers.dart';

part 'userGroup.g.dart';

abstract class UserGroup implements Built<UserGroup, UserGroupBuilder> {
  UserGroup._();

  factory UserGroup([updates(UserGroupBuilder b)]) = _$UserGroup;

  @BuiltValueField(wireName: 'id')
  int? get id;

  @BuiltValueField(wireName: 'userID')
  int? get userID;

  @BuiltValueField(wireName: 'groupID')
  int? get groupID;

  @BuiltValueField(wireName: 'groupName')
  String get groupName;

  String toJson() {
    return json.encode(serializers.serializeWith(UserGroup.serializer, this));
  }

  static UserGroup? fromJson(String jsonString) {
    return serializers.deserializeWith(
        UserGroup.serializer, json.decode(jsonString));
  }

  static BuiltList<UserGroup> listFromJson(jsonString) {
    return BuiltList<UserGroup>.from(json
        .decode(jsonString)
        .map(
            (value) => serializers.deserializeWith(UserGroup.serializer, value))
        .toList());
  }

  static Serializer<UserGroup> get serializer => _$userGroupSerializer;
}
