library user_organization;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../../serializers.dart';

part 'userOrganization.g.dart';

abstract class UserOrganization
    implements Built<UserOrganization, UserOrganizationBuilder> {
  UserOrganization._();

  factory UserOrganization([updates(UserOrganizationBuilder b)]) =
      _$UserOrganization;

  @BuiltValueField(wireName: 'id')
  int get id;

  @BuiltValueField(wireName: 'ownerID')
  int get ownerID;

  @BuiltValueField(wireName: 'name')
  String get name;

  @BuiltValueField(wireName: 'token')
  String get token;

  @BuiltValueField(wireName: 'organizationType')
  String get organizationType;

  @BuiltValueField(wireName: 'referenceID')
  int get referenceID;

  @BuiltValueField(wireName: 'relationID')
  int get relationID;

  @BuiltValueField(wireName: 'ownerFullName')
  String get ownerFullName;

  @BuiltValueField(wireName: 'ownerEmail')
  String get ownerEmail;

  String toJson() {
    return json
        .encode(serializers.serializeWith(UserOrganization.serializer, this));
  }

  static UserOrganization? fromJson(String jsonString) {
    return serializers.deserializeWith(
        UserOrganization.serializer, json.decode(jsonString));
  }

  static BuiltList<UserOrganization> listFromJson(jsonString) {
    return BuiltList<UserOrganization>.from(json
        .decode(jsonString)
        .map((value) =>
            serializers.deserializeWith(UserOrganization.serializer, value))
        .toList());
  }

  static Serializer<UserOrganization> get serializer =>
      _$userOrganizationSerializer;
}
