library verification_code;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

import '../../serializers.dart';

part 'verificationCode.g.dart';

abstract class VerificationCode
    implements Built<VerificationCode, VerificationCodeBuilder> {
  VerificationCode._();

  factory VerificationCode([updates(VerificationCodeBuilder b)]) =
      _$VerificationCode;

  @BuiltValueField(wireName: 'id')
  int get id;

  @BuiltValueField(wireName: 'userID')
  int get userID;

  @BuiltValueField(wireName: 'kind')
  String get kind;

  @BuiltValueField(wireName: 'value')
  String get value;

  @BuiltValueField(wireName: 'code')
  String get code;

  @BuiltValueField(wireName: 'createdAt')
  String get createdAt;

  String toJson() {
    return json
        .encode(serializers.serializeWith(VerificationCode.serializer, this));
  }

  static VerificationCode? fromJson(String jsonString) {
    return serializers.deserializeWith(
        VerificationCode.serializer, json.decode(jsonString));
  }

  static BuiltList<VerificationCode> listFromJson(jsonString) {
    return BuiltList<VerificationCode>.from(json
        .decode(jsonString)
        .map((value) =>
            serializers.deserializeWith(VerificationCode.serializer, value))
        .toList());
  }

  static Serializer<VerificationCode> get serializer =>
      _$verificationCodeSerializer;
}
