import 'package:flutter/material.dart';

class CredentialsView extends StatefulWidget {
  final Widget? header;
  final Widget? footer;
  final Widget? illustration;
  final Widget? biometricChild;
  final Widget child;

  const CredentialsView({
    Key? key,
    this.header,
    this.footer,
    this.illustration,
    this.biometricChild,
    required this.child,
  }) : super(key: key);

  @override
  _CredentialsViewState createState() => _CredentialsViewState();
}

class _CredentialsViewState extends State<CredentialsView> {
  @override
  void initState() {
    super.initState();

    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.only(top: 40.0),
      child: ListView(
        children: [
          Stack(
            children: [
              if (widget.header != null)
                Positioned(
                  left: 0.0,
                  top: 0.0,
                  child: new Container(
                    width: MediaQuery.of(context).size.width,
                    decoration: new BoxDecoration(color: Colors.grey.shade300),
                    child: widget.header,
                  ),
                ),
              if (widget.footer != null)
                Positioned(
                  left: 0.0,
                  bottom: 0.0,
                  child: new Container(
                    width: MediaQuery.of(context).size.width,
                    decoration: new BoxDecoration(color: Colors.grey.shade300),
                    child: widget.footer,
                  ),
                ),
              Column(
                mainAxisAlignment: MainAxisAlignment.center,
                crossAxisAlignment: CrossAxisAlignment.center,
                children: [
                  Padding(
                    padding: const EdgeInsets.all(20.0),
                    child: Center(
                      child: Container(
                        width: MediaQuery.of(context).size.width - 40 > 600
                            ? 600
                            : MediaQuery.of(context).size.width - 40,
                        child: Wrap(
                          alignment: WrapAlignment.center,
                          runSpacing: 10.0,
                          children: [
                            widget.illustration ?? Text(""),
                            widget.child,
                          ],
                        ),
                      ),
                    ),
                  ),
                  if (widget.biometricChild != null) widget.biometricChild!,
                ],
              ),
            ],
          ),
        ],
      ),
    );
  }
}
