import 'package:flutter/material.dart';

class SigninMethodSwitch extends StatefulWidget {
  final bool plEnabled;
  final void Function()? toggle;

  const SigninMethodSwitch({
    Key? key,
    required this.plEnabled,
    this.toggle,
  }) : super(key: key);

  @override
  _SigninMethodSwitchState createState() => _SigninMethodSwitchState();
}

class _SigninMethodSwitchState extends State<SigninMethodSwitch> {
  bool plEnabled = false;

  @override
  void initState() {
    super.initState();

    setState(() {
      plEnabled = widget.plEnabled;
    });
  }

  @override
  void didUpdateWidget(SigninMethodSwitch oldWidget) {
    super.didUpdateWidget(oldWidget);

    setState(() {
      plEnabled = widget.plEnabled;
    });
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        if (widget.toggle != null) widget.toggle!();
      },
      child: Center(
        child: Opacity(
          opacity: 0.58,
          child: Container(
            child: Padding(
              padding: const EdgeInsets.only(
                  left: 4.0, right: 4.0, top: 2, bottom: 2),
              child: Wrap(
                children: [
                  Padding(
                    padding: const EdgeInsets.only(right: 4.0),
                    child: Image.asset(
                      plEnabled ? 'lib/assets/key.png' : 'lib/assets/wand.png',
                      package: "account_kit",
                      width: 12,
                      color: Theme.of(context).textTheme.bodyText2!.color,
                    ),
                  ),
                  Text(
                    plEnabled
                        ? "Signin with my password"
                        : "Send me a password free sign in code",
                    textAlign: TextAlign.center,
                    style: Theme.of(context).textTheme.bodyText2!,
                  ),
                ],
              ),
            ),
          ),
        ),
      ),
    );
  }
}
