import 'package:account_kit/helpers/regex.dart';
import 'package:account_kit/redux/accountKitState.dart';
import 'package:account_kit/redux/user/userActions.dart';
import 'package:flutter/material.dart';
import 'package:flutter_redux/flutter_redux.dart';
import 'package:puma_network/widget/apiButton.dart';
import 'package:redux/redux.dart';

class PasswordSignin<T extends VirtualAccountState> extends StatefulWidget {
  const PasswordSignin({
    Key? key,
  }) : super(key: key);

  @override
  _PasswordSigninState createState() => _PasswordSigninState<T>();
}

class _PasswordSigninState<T extends VirtualAccountState>
    extends State<PasswordSignin> {
  TextEditingController emailController = TextEditingController();
  TextEditingController passwordController = TextEditingController();
  final FocusNode _emailFocus = FocusNode();
  final FocusNode _passwordFocus = FocusNode();
  String _email = '';
  bool showApiError = true;

  @override
  void initState() {
    super.initState();

    setState(() {});
  }

  handleEmailChange(value) {
    setState(() {
      _email = value;
      showApiError = false;
    });
  }

  bool isButtonDisabled(_ViewModel vm) {
    print(_email);

    if (isEmailMatch(_email)) {
      return false;
    }

    print("${this.passwordController.text.length}");
    if (this.passwordController.text.length > 0) {
      print("false");
      return false;
    }

    print("true");
    return true;
  }

  @override
  Widget build(BuildContext context) {
    return StoreConnector<T, _ViewModel>(
      converter: (Store<T> store) => _ViewModel.create(store),
      onDidChange: (vm1, vm2) {},
      onInitialBuild: (vm) {},
      builder: (BuildContext context, _ViewModel vm) =>
          _createBody(context, vm),
    );
  }

  Widget _createBody(BuildContext context, _ViewModel vm) {
    return Column(
      children: [
        TextFormField(
          autofocus: true,
          enableSuggestions: false,
          autocorrect: false,
          controller: emailController,
          keyboardAppearance: Theme.of(context).brightness,
          focusNode: _emailFocus,
          onChanged: this.handleEmailChange,
          decoration: InputDecoration(
            hintText: 'Email',
          ),
          onFieldSubmitted: (value) {
            FocusScope.of(context).unfocus();
            FocusScope.of(context).requestFocus(_passwordFocus);
          },
          keyboardType: TextInputType.emailAddress,
          validator: (value) {
            if (value!.isEmpty) {
              return 'Please enter some text';
            }
            return null;
          },
        ),
        Container(
          padding: const EdgeInsets.all(5.0),
        ),
        TextFormField(
          controller: passwordController,
          focusNode: _passwordFocus,
          keyboardAppearance: Theme.of(context).brightness,
          obscureText: true,
          decoration: const InputDecoration(
            hintText: 'Password',
          ),
          onFieldSubmitted: (value) {
            _passwordFocus.unfocus();
          },
          validator: (value) {
            if (value != null && value.isEmpty) {
              return 'Please enter some text';
            }
            return null;
          },
        ),
        Container(
          padding: const EdgeInsets.all(5.0),
        ),
        ApiButton<T>(
          label: "Signin",
          disabled: isButtonDisabled(vm),
          color: Theme.of(context).colorScheme.secondary,
          apiCall: () {
            FocusScope.of(context).unfocus();

            return vm.signin(
                this.emailController.text, this.passwordController.text);
          },
        ),
      ],
    );
  }
}

class _ViewModel {
  final Function(String, String) signin;

  _ViewModel(
    this.signin,
  );

  factory _ViewModel.create(Store<VirtualAccountState> store) {
    return _ViewModel(
      (email, password) => store.dispatch(PostSignin(email, password)),
    );
  }
}
